package cn.zhangdeman.logger;

import ch.qos.logback.classic.spi.ILoggingEvent;
import cn.zhangdeman.consts.RecordField;
import cn.zhangdeman.context.RuntimeContext;
import com.fasterxml.jackson.core.JsonGenerator;

import java.io.IOException;
import java.util.Objects;

// 记录请求信息
public class RequestInfoLogProvider extends BaseProvider {
    @Override
    public void writeTo(JsonGenerator gen, ILoggingEvent event) throws IOException {
        RuntimeContext runtimeContext = getCurrentRequest();
        if (null == runtimeContext) {
            // 非 http 请求不应该用到这个provider
            return;
        }
        if (Objects.equals(getLoggerType(event), LogTypeEnum.REQUEST_INPUT.getLogType())) {
            // 请求输入日志
            writeCommonField(runtimeContext, gen, runtimeContext.getRequestInfo());
        } else if (Objects.equals(getLoggerType(event), LogTypeEnum.REQUEST_OUTPUT.getLogType())) {
            // 请求输出日志
            writeCommonField(runtimeContext, gen, runtimeContext.getResponse());
        } else {
            System.out.println("请求信息记录器需要将日志的类型设置为: input(请求记录) 或 output(响应记录)");
        }
    }
}
